<?php
namespace Supportingcast\Woocommere;

use Supportingcast\ScProducts;

AdminProductData::boot();

class AdminProductData
{
	const META_PRODUCT_ID = 'supportingcast_product_id';


    public static function boot()
    {
        $adminProductData = new AdminProductData();

        add_filter('woocommerce_product_data_tabs', [$adminProductData, 'filter_woocommerce_product_data_tabs'] );

        add_action('woocommerce_product_data_panels', [$adminProductData, 'action_woocommerce_product_data_panels'] );

        add_action('woocommerce_process_product_meta', [$adminProductData, 'action_woocommerce_process_product_meta'] );

    }

    public function filter_woocommerce_product_data_tabs($tabs) {
        $tabs['supportingcast'] = [
            'label'    => __( 'Supporting Cast', 'woocommerce' ),
            'target'   => 'supportingcast_product_data',
            'class'    => [],
            'priority' => 11,
        ];

        return $tabs;
    }

    public function action_woocommerce_product_data_panels() {
            include(__DIR__ . '/../../views/WoocommerceAdminProductData.php');
    }

    // Save data from form
    public function action_woocommerce_process_product_meta($postId)
    {
        $productName = $_POST['post_title'];
        $description = $_POST['content'];
    	$feedIds = $_POST['supportingcast_feed_ids'];
    	$visibility = $_POST['visibility'];

        $scProductId = get_post_meta($postId, self::META_PRODUCT_ID, true);

        $data = [
        	'name' => $productName,
	        'type' => 'wordpress',
	        'data' => [
	        	'woocommerce_product_id' => $postId,
		        'description' => $description ?? "Woocommerce Product #{$postId}",
	        ],
	        'free' => true, // Payments are not made through Supporting Cast
	        'status' => ($visibility === 'private' ? 'hidden' : 'active'),
	        'feed_ids' => $feedIds,
        ];


        if (empty($feedIds)) {
        	return;
        }

        if ($scProductId == 0) {
        	$scProduct = new ScProducts();
        	$scProduct->create($data);
        	update_post_meta($postId, self::META_PRODUCT_ID, $scProduct->id);
        }
        if ($scProductId > 0) {
	        $scProduct = new ScProducts();
	        $scProduct->updateId($scProductId, $data);
        }

    }

}